
  2004.10.29 (q1)
    - HTMLǡʸɤ$KCODE¸ˤʤäƤŪ˻Ǥ褦ˤ
      HTMLSplit.new()2ǻꤹ롣UTF-8ϡ$KCODE˹碌ơ"UTF8"
    - HTMLǡʸɤUTF-8ΤȤɥݥ0x100ʾʸȤ
      褦ˤ
    - XMLζǥ᤹褦ˤStartTagȸʤ
    - ʥн褷'<'Τߡ'<>''<0'ʤɡ
    - ĤʤϥĤʤλн褷
    - ƥȥɲä

  2005.01.03 (q2)
    - ǥȽꤹ륿ѹǤ褦ˤHTMLSplit#empty_tags
      ѹФ
    - HTMLSplit.new()HTMLƥȤϤʤƤ⤤褦ˤ
      HTMLSplit#set_html()ߡΤ褦ˤƻȤ
      scanner = HTMLSplit.new()
      scanner.empty_tags << "x:foo"
      scanner.set_html(html)
    - ƥȥɲá

diff -Naurw --minimal htmlsplit102.orig/htmlsplit.rb htmlsplit102-cur/htmlsplit.rb
--- htmlsplit102.orig/htmlsplit.rb	2004-11-21 21:47:38.000000000 +0900
+++ htmlsplit102-cur/htmlsplit.rb	2005-01-03 15:38:53.791644912 +0900
@@ -384,7 +384,61 @@
 class HTMLSplit
 	EMPTY = %w(area base basefont bgsound br col frame hr img input isindex 
 	           keygen link meta nextid param spacer wbr)
-	def initialize(html)
+
+  def HTMLSplit.make_char(encoding, code, unmatch)
+    if code == 0x9 || code == 0xa || code == 0xd || code >= 0x20 && code <= 0xff
+      code.chr
+    else
+      if (code <= 0xd7ff ||
+          code >= 0xe000 && code <= 0x10ffff && code != 0xfffe && code != 0xffff) && 
+         encoding == "UTF8"
+        [code].pack("U")
+      else
+        unmatch
+      end
+    end
+  end
+
+  def HTMLSplit.unescapeHTML(string, encoding)
+    string.gsub(/&(.*?);/n) {
+      match = $1.dup
+      case match
+      when /\Aamp\z/ni           then '&'
+      when /\Aquot\z/ni          then '"'
+      when /\Aapos\z/ni          then "'"
+      when /\Agt\z/ni            then '>'
+      when /\Alt\z/ni            then '<'
+      when /\A#0*(\d+)\z/n
+        HTMLSplit.make_char(encoding, Integer($1), "&##{$1};")
+      when /\A#x([0-9a-f]+)\z/ni
+        HTMLSplit.make_char(encoding, $1.hex, "&#x#{$1};")
+      else
+        "&#{match};"
+      end
+    }
+  end
+
+  def make_tag(name, attr)
+    name.downcase!
+    if @empty_tags.include?(name)
+      @document << EmptyElementTag.new(name, attr)
+    else
+      if name[0, 1] == '/'
+        @document << EndTag.new(name[1..-1])
+      else
+        @document << StartTag.new(name, attr)
+      end
+    end
+  end
+  private :make_tag
+
+  def initialize(html = nil, encoding = $KCODE)
+    @empty_tags = EMPTY
+    set_html(html, encoding) if html
+  end
+  attr_accessor :empty_tags
+
+  def set_html(html, encoding = $KCODE)
 		@document = []	#ѡHTMLΥꥹ
 		name = ''
 		text = ''
@@ -407,20 +461,8 @@
 					text << char
 				end
 			when :TAGNAME
+        if name.length == 0
 				case char
-				when '>'
-					name.downcase!
-					if EMPTY.include?(name)
-						@document << EmptyElementTag.new(name,nil)
-					else
-						if name[0,1]=='/'
-							@document << EndTag.new(name[1..-1])
-						else
-							@document << StartTag.new(name,nil)
-						end
-					end
-					text = ''
-					state = :TEXT
 				when '!'
 					text = ''
 					state = :DECLARE
@@ -430,27 +472,40 @@
 				when '?'
 					text = ''
 					state = :PHP
+          when /[a-zA-Z_:\/]/
+            name << char
+          else
+            text = '<' + char
+            state = :TEXT
+          end
+        else
+          case char
+          when '>'
+            make_tag(name, nil)
+            text = ''
+            state = :TEXT
 				when /\s/
 					text=''
 					state = :SPACE
-				else
+          when /[a-zA-Z0-9\._:-]/
 					name << char
+          else
+            text = ''
+            state = :SPACE
+            redo
+          end
 				end
 			when :SPACE	#°֤ζ
 				case char
 				when '>'
-					name.downcase!
-					if EMPTY.include?(name)
-						@document << EmptyElementTag.new(name,attr)
-					else
-						if name[0,1]=='/'
-							@document << EndTag.new(name[1..-1])
-						else
-							@document << StartTag.new(name,attr)
-						end
-					end
+          make_tag(name, attr)
 					text = ''
 					state = :TEXT
+        when '<'  # Ĥʤϥ
+          make_tag(name, attr)
+          name = ''
+          attr = {}
+          state = :TAGNAME
 				when /\s/
 				else
 					attrname=char
@@ -464,16 +519,7 @@
 					state = :AFTEREQUAL
 				when '>'
 					attr[attrname.downcase]=true
-					name.downcase!
-					if EMPTY.include?(name)
-						@document << EmptyElementTag.new(name,attr)
-					else
-						if name[0,1]=='/'
-							@document << EndTag.new(name[1..-1])
-						else
-							@document << StartTag.new(name,attr)
-						end
-					end
+          make_tag(name, attr)
 					text = ''
 					state = :TEXT
 				else
@@ -485,16 +531,7 @@
 					state = :AFTEREQUAL
 				when '>'
 					attr[attrname.downcase]=true
-					name.downcase!
-					if EMPTY.include?(name)
-						@document << EmptyElementTag.new(name,attr)
-					else
-						if name[0,1]=='/'
-							@document << EndTag.new(name[1..-1])
-						else
-							@document << StartTag.new(name,attr)
-						end
-					end
+          make_tag(name, attr)
 					text = ''
 					state = :TEXT
 				when /\s/
@@ -513,16 +550,7 @@
 					state = :DQVALUE
 				when '>'
 					attr[attrname.downcase]=true
-					name.downcase!
-					if EMPTY.include?(name)
-						@document << EmptyElementTag.new(name,attr)
-					else
-						if name[0,1]=='/'
-							@document << EndTag.new(name[1..-1])
-						else
-							@document << StartTag.new(name,attr)
-						end
-					end
+          make_tag(name, attr)
 					text = ''
 					state = :TEXT
 				when /\s/
@@ -533,20 +561,11 @@
 			when :VALUE		#
 				case char
 				when /\s/
-					attr[attrname.downcase]=CGI::unescapeHTML(text)
+          attr[attrname.downcase] = HTMLSplit.unescapeHTML(text, encoding)
 					state = :SPACE
 				when '>'
-					attr[attrname.downcase]=CGI::unescapeHTML(text)
-					name.downcase!
-					if EMPTY.include?(name)
-						@document << EmptyElementTag.new(name,attr)
-					else
-						if name[0,1]=='/'
-							@document << EndTag.new(name[1..-1])
-						else
-							@document << StartTag.new(name,attr)
-						end
-					end
+          attr[attrname.downcase] = HTMLSplit.unescapeHTML(text, encoding)
+          make_tag(name, attr)
 					text = ''
 					state = :TEXT
 				else
@@ -554,14 +573,14 @@
 				end
 			when :SQVALUE	#''
 				if c==39
-					attr[attrname.downcase]=CGI::unescapeHTML(text)
+          attr[attrname.downcase] = HTMLSplit.unescapeHTML(text, encoding)
 					state = :SPACE
 				else
 					text << char
 				end
 			when :DQVALUE	#""
 				if c==34
-					attr[attrname.downcase]=CGI::unescapeHTML(text)
+          attr[attrname.downcase] = HTMLSplit.unescapeHTML(text, encoding)
 					state = :SPACE
 				else
 					text << char
@@ -634,68 +653,23 @@
 		when :TAGNAME
 			@document << CharacterData.new('<'+text)
 		when :SPACE	#°֤ζ
-			name.downcase!
-			if EMPTY.include?(name)
-				@document << EmptyElementTag.new(name,attr)
-			else
-				if name[0,1]=='/'
-					@document << EndTag.new(name[1..-1])
-				else
-					@document << StartTag.new(name,attr)
-				end
-			end
+      make_tag(name, attr)
 		when :ATTRNAME	#°̾
 			attr[attrname.downcase]=true
-			name.downcase!
-			if EMPTY.include?(name)
-				@document << EmptyElementTag.new(name,attr)
-			else
-				if name[0,1]=='/'
-					@document << EndTag.new(name[1..-1])
-				else
-					@document << StartTag.new(name,attr)
-				end
-			end
+      make_tag(name, attr)
 		when :BEFOREEQUAL	#=
 			attr[attrname.downcase]=true
-			name.downcase!
-			if EMPTY.include?(name)
-				@document << EmptyElementTag.new(name,attr)
-			else
-				if name[0,1]=='/'
-					@document << EndTag.new(name[1..-1])
-				else
-					@document << StartTag.new(name,attr)
-				end
-			end
+      make_tag(name, attr)
 		when :AFTEREQUAL	#=
 			attr[attrname.downcase]=true
-			name.downcase!
-			if EMPTY.include?(name)
-				@document << EmptyElementTag.new(name,attr)
-			else
-				if name[0,1]=='/'
-					@document << EndTag.new(name[1..-1])
-				else
-					@document << StartTag.new(name,attr)
-				end
-			end
+      make_tag(name, attr)
 		when :VALUE		#
-			attr[attrname.downcase]=CGI::unescapeHTML(text)
-			name.downcase!
-			if EMPTY.include?(name)
-				@document << EmptyElementTag.new(name,attr)
-			else
-				if name[0,1]=='/'
-					@document << EndTag.new(name[1..-1])
-				else
-					@document << StartTag.new(name,attr)
-				end
-			end
+      attr[attrname.downcase] = HTMLSplit.unescapeHTML(text, encoding)
+      make_tag(name, attr)
 		when :SQVALUE	#''
-			attr[attrname.downcase]=CGI::unescapeHTML(text)
+      attr[attrname.downcase] = HTMLSplit.unescapeHTML(text, encoding)
 		when :DQVALUE	#""
-			attr[attrname.downcase]=CGI::unescapeHTML(text)
+      attr[attrname.downcase] = HTMLSplit.unescapeHTML(text, encoding)
 		when :COMMENT
 			if text=~/^#[a-zA-Z]+/	#SSI
 				@document << SSI.new(text)
diff -Naurw --minimal htmlsplit102.orig/splittest.rb htmlsplit102-cur/splittest.rb
--- htmlsplit102.orig/splittest.rb	2004-11-21 21:47:38.000000000 +0900
+++ htmlsplit102-cur/splittest.rb	1970-01-01 09:00:00.000000000 +0900
@@ -1,7 +0,0 @@
-#!/usr/bin/ruby
-require "htmlsplit"
-
-obj = HTMLSplit.new(ARGF.read)
-obj.document.each {|e|
-	print e.to_s
-}
diff -Naurw --minimal htmlsplit102.orig/test/ref-test.rb htmlsplit102-cur/test/ref-test.rb
--- htmlsplit102.orig/test/ref-test.rb	1970-01-01 09:00:00.000000000 +0900
+++ htmlsplit102-cur/test/ref-test.rb	2005-01-03 15:30:09.622171368 +0900
@@ -0,0 +1,59 @@
+
+require "test/unit/testcase"
+require "test/unit/ui/console/testrunner"
+
+require "htmlsplit"
+
+# JIS XML ܼ
+# http://www.y-adagio.com/public/standards/jis_xml/toc.html
+
+# IT䤵ɤXML 1.0 22ʪ¤ˤʸȡפȡּλȡ
+# http://www.atmarkit.co.jp/fxml/rensai/w3cread22/w3cread22_1.html
+
+class RefTest < Test::Unit::TestCase
+  # 
+  def test11
+    html = "<e>hoge&lt;hoge</e>"
+    o = HTMLSplit.new(html)
+    assert_equal("hoge&lt;hoge", o.document[1].to_s)   # ޤʤ
+  end
+
+  def test12
+    html = "<e>hoge&#41;hoge</e>"
+    o = HTMLSplit.new(html)
+    assert_equal("hoge&#41;hoge", o.document[1].to_s)  # ޤʤ
+  end
+
+  # °
+  def test13
+    html = "<e foo='hoge&lt;hoge'>"
+    o = HTMLSplit.new(html)
+    assert_equal("hoge<hoge", o.document[0].attr["foo"])  # 
+  end
+
+  def test14
+    html = "<e foo='&#41;'>"
+    o = HTMLSplit.new(html)
+    assert_equal(")", o.document[0].attr["foo"])   # 
+  end
+
+  # 2ɲ
+  def test15
+    html = "<e foo='&#x4100;'>"
+    o = HTMLSplit.new(html)
+    assert_equal("&#x4100;", o.document[0].attr["foo"])
+    o = HTMLSplit.new(html, "UTF8")                        # UTF8ξΤ߼
+    assert_equal([0x4100].pack("U"), o.document[0].attr["foo"])
+  end
+
+  def test21
+    html = "<e foo='&#xd7ff;'>"
+    o = HTMLSplit.new(html, "UTF8")
+    assert_equal([0xd7ff].pack("U"), o.document[0].attr["foo"])
+    html = "<e foo='&#xd800;'>"
+    o = HTMLSplit.new(html, "UTF8")
+    assert_equal("&#xd800;", o.document[0].attr["foo"])   # ΰϼޤʤ
+  end
+end
+
+Test::Unit::UI::Console::TestRunner.new(RefTest).start()
diff -Naurw --minimal htmlsplit102.orig/test/struct-test.rb htmlsplit102-cur/test/struct-test.rb
--- htmlsplit102.orig/test/struct-test.rb	1970-01-01 09:00:00.000000000 +0900
+++ htmlsplit102-cur/test/struct-test.rb	2005-01-03 18:11:03.028970728 +0900
@@ -0,0 +1,143 @@
+
+require "test/unit/testcase"
+require "test/unit/ui/console/testrunner"
+
+require "htmlsplit"
+
+class StructureTest < Test::Unit::TestCase
+  # 
+  def test11
+    html = "<!--  <foo> & <bar> -->"
+    o = HTMLSplit.new(html)
+    assert_equal("  <foo> & <bar> ", o.document[0].text)
+  end
+
+  # ʥȡWeb֥饦Ǥϡ"-->"ޤǥȤˤʤ롣
+  def test12
+    html = "<!-- foo -- bar -->"
+    o = HTMLSplit.new(html)
+    assert_equal(" foo -- bar ", o.document[0].text)
+  end
+
+  # ̿ (PI)
+  def test21
+    html = "<?hoge <foo> & <bar> ?>"
+    o = HTMLSplit.new(html)
+    assert_instance_of(PHP, o.document[0])
+    assert_equal("hoge <foo> & <bar> ", o.document[0].text)   # PITargetǧʤ
+  end
+
+=begin
+  # CDATA
+  def test31
+  end
+=end
+
+  # ʸ
+  def test41
+    html = '<!DOCTYPE greeting SYSTEM "hello.dtd">'
+    o = HTMLSplit.new(html)
+    assert_instance_of(Declaration, o.document[0])
+    assert_equal('DOCTYPE greeting SYSTEM "hello.dtd"', o.document[0].text)
+  end
+
+=begin
+  # ֥å
+  def test42
+    html = '<!DOCTYPE greeting [ <!ELEMENT greeting (#PCDATA)> ]>'
+    o = HTMLSplit.new(html)
+    assert_instance_of(Declaration, o.document[0])
+    assert_equal('DOCTYPE greeting SYSTEM "hello.dtd"', o.document[0].text)
+  end
+=end
+
+  # ϥ
+  def test51
+    html = "<foo bar='hoge'>"    # '...'ǰϤǤ褤
+    o = HTMLSplit.new(html)
+    tag = o.document[0]
+    assert_instance_of(StartTag, tag)
+    assert_equal({"bar" => "hoge"}, tag.attr)
+  end
+
+  # ǥ (XML)
+  # empty_tagsˤʤȤStartTag֤
+  #       HTMLʥץꥱˤXMLƤʤ
+  def test52
+    html = "<foo/>"
+    o = HTMLSplit.new(html)
+    tag = o.document[0]
+    assert_instance_of(StartTag, tag)
+    assert_equal({"/" => true}, tag.attr)
+  end
+
+  # ʥ
+  def test53
+    html = "<0> < <>"
+    o = HTMLSplit.new(html)
+    assert_instance_of(CharacterData, o.document[0])
+    assert_equal("<0> ", o.document[0].text)
+    assert_instance_of(CharacterData, o.document[1])
+    assert_equal("< ", o.document[1].text)
+    assert_instance_of(CharacterData, o.document[2])
+    assert_equal("<>", o.document[2].text)
+  end
+
+  # λ
+  def test54
+    html = "</foo>"
+    o = HTMLSplit.new(html)
+    tag = o.document[0]
+    assert_instance_of(EndTag, tag)
+    assert_equal("foo", tag.name)
+  end
+
+  # SGMLǤϡ°ͤ켰ΤȤϡ°̾άǤ롣
+  # °̾ά줿ϡ°=>true֤
+  def test55
+    html = "<foo bar>"
+    o = HTMLSplit.new(html)
+    tag = o.document[0]
+    assert_instance_of(StartTag, tag)
+    assert_equal({"bar" => true}, tag.attr)
+    assert_equal("<foo bar>", tag.to_s)
+  end
+
+  # Ĥʤϥ     SGMLǵꡣWeb֥饦ǤᤷƤ
+  def test61
+    html = "<foo<bar>"
+    o = HTMLSplit.new(html)
+    tag = o.document[0]
+    assert_instance_of(StartTag, tag)
+    assert_equal("foo", tag.name)
+    tag = o.document[1]
+    assert_instance_of(StartTag, tag)
+    assert_equal("bar", tag.name)
+  end
+
+  # Ĥʤλ    SGMLǵꡣWeb֥饦ǤᤷƤ
+  def test62
+    html = "</foo</bar>"
+    o = HTMLSplit.new(html)
+    tag = o.document[0]
+    assert_instance_of(EndTag, tag)
+    assert_equal("foo", tag.name)
+    tag = o.document[1]
+    assert_instance_of(EndTag, tag)
+    assert_equal("bar", tag.name)
+  end
+
+  # ǥȽꤹ륿̾ɲá
+  def test71
+    html = "<x:foo>"
+    o = HTMLSplit.new()
+    o.empty_tags << "x:foo"
+    o.set_html(html)
+    tag = o.document[0]
+
+    assert_instance_of(EmptyElementTag, tag)
+    assert_equal("x:foo", tag.name)
+  end
+end
+
+Test::Unit::UI::Console::TestRunner.new(StructureTest).start()
